use 5.010;
use strict;
use warnings;
use ExtUtils::MakeMaker;
# See lib/ExtUtils/MakeMaker.pm for details of how to influence
# the contents of the Makefile that is written.
WriteMakefile(
    NAME              => 'Urb',
    VERSION_FROM      => 'lib/Urb.pm', # finds $VERSION
    EXE_FILES         => [ 'bin/urb-combine.pl', 'bin/urb-dom2svg.pl', 'bin/urb-shuffle.pl',
                           'bin/urb-fitness.pl', 'bin/urb-rearrange.pl', 'bin/urb-upgrade.pl',
                           'bin/urb-multiply.pl', 'bin/urb-mutate.pl', 'bin/field2equirect.pl',
                           'bin/urb-prettytree.pl', 'bin/urb-dom2field.pl', 'bin/urb-reallocate.pl',
                           'bin/urb-dom2tree.pl', 'bin/urb-dom2net.pl', 'bin/urb-default.pl',
                           'bin/urb-env.pl', 'bin/urb-dom2molior.pl', 'bin/urb-evolve.pl',
                           'bin/urb-reap.pl', 'bin/urb-rotate.pl', 'bin/urb-shift.pl',
                           'bin/field2pgm.pl', 'bin/dom2dxf.sh', 'bin/urb-offset.pl',
                           'bin/urb-crinkliness.pl', 'bin/urb-svgappend.pl', 'bin/urb-fill.pl',
                           'bin/urb-straighten.pl', 'bin/urb-areas.pl', 'bin/urb-topologise.pl'],
    PREREQ_PM         => {'Math::Polygon' => 1.00, YAML => 0.5, Graph => 0.8, SVG => 2.0, 'Test::More' => 0.1, 'Algorithm::Evolutionary' => 0.80, 'File::Copy' => 2.0, 'File::Spec' => 3.0, 'File::Temp' => 0.2000, 'Math::Trig' => 1.0}, # e.g., Module::Name => 1.1
    ($] >= 5.005 ?     ## Add these new keywords supported since 5.005
      (ABSTRACT_FROM  => 'lib/Urb.pm', # retrieve abstract from module
       LICENSE => 'GPL',
       AUTHOR         => 'Bruno Postle <bruno@postle.net>') : ()),
);
